
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "pid"
})
public class Usv implements Serializable
{

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("pid")
    private String pid;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = 7560435951072023890L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public Usv() {
    }

    /**
     * 
     * @param pid
     */
    public Usv(String pid) {
        super();
        this.pid = pid;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("pid")
    public String getPid() {
        return pid;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("pid")
    public void setPid(String pid) {
        this.pid = pid;
    }

    public Usv withPid(String pid) {
        this.pid = pid;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public Usv withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(Usv.class.getName()).append('@').append(Integer.toHexString(System.identityHashCode(this))).append('[');
        sb.append("pid");
        sb.append('=');
        sb.append(((this.pid == null)?"<null>":this.pid));
        sb.append(',');
        sb.append("additionalProperties");
        sb.append('=');
        sb.append(((this.additionalProperties == null)?"<null>":this.additionalProperties));
        sb.append(',');
        if (sb.charAt((sb.length()- 1)) == ',') {
            sb.setCharAt((sb.length()- 1), ']');
        } else {
            sb.append(']');
        }
        return sb.toString();
    }

    @Override
    public int hashCode() {
        int result = 1;
        result = ((result* 31)+((this.pid == null)? 0 :this.pid.hashCode()));
        result = ((result* 31)+((this.additionalProperties == null)? 0 :this.additionalProperties.hashCode()));
        return result;
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof Usv) == false) {
            return false;
        }
        Usv rhs = ((Usv) other);
        return (((this.pid == rhs.pid)||((this.pid!= null)&&this.pid.equals(rhs.pid)))&&((this.additionalProperties == rhs.additionalProperties)||((this.additionalProperties!= null)&&this.additionalProperties.equals(rhs.additionalProperties))));
    }

}
